import { CountDocumentsOptions, Filter, MatchKeysAndValues, UpdateFilter, UpdateOptions, UpdateResult } from 'mongodb';
import { MongoCollection, MongoCollectionOptions, MongoDatabase, MongoDocument } from './mongodb';
export declare class Collection<TEntity extends MongoDocument> extends MongoCollection<TEntity> {
    private readonly locker;
    constructor(db: MongoDatabase, name?: string, options?: MongoCollectionOptions);
    countDocuments(filter?: Filter<TEntity>, options?: CountDocumentsOptions): Promise<number>;
    upsert(filter: Filter<TEntity>, update: UpdateFilter<TEntity> | Partial<TEntity>, options?: UpdateOptions | undefined): Promise<UpdateResult<TEntity>>;
    withDocumentLock<TReturn>(filter: MatchKeysAndValues<TEntity>, handle: () => Promise<TReturn> | TReturn): Promise<TReturn>;
    private lock;
    private unlock;
    private unlockWithResult;
}
